import json
import os
import sys

from functions import RequestError
from functions import get_token
from functions import load_global_file
from functions import post_data_records

assert sys.version_info >= (3, 7)

script_path = os.path.dirname(os.path.realpath(__file__))
drs_path = script_path + "/../drs/"


def __create_drs(drs_file, domain_name, domain_version, global_file):
    f = open(drs_path + drs_file, "r")

    try:
        json_in = json.load(f)

        print("\n*** DR INFORMATION ***")
        print("Domain Name:        " + domain_name)
        print("Domain Version:     " + str(domain_version))
        print("Record Count:       " + str(len(json_in)))

        # Get the token
        gf = load_global_file(global_file)
        token = get_token(gf["token_href"], gf["client_id"], gf["client_secret"], gf["dgs_username"], gf["dgs_password"])

        # Create the DRs
        try:
            post_data_records(gf["href"], token, domain_name, domain_version, json_in)
        except RequestError as e:
            if e.status_code != 409:
                raise e

    finally:
        f.close()


def create_drs(global_file):
    print("Creating employeeClassification Data Records")
    __create_drs("employee_classification.json", "employeeClassification", 1, global_file)
