#!/usr/bin/python3

import load
import os
import sys
import time
import random

# 
# Load all of the data in the ../test-data-sustained directory. Should take several hours to complete.
#
# For more on how the data is generated etc. see ../test-data-sustained/readme.md
#

assert sys.version_info >= (3, 7)

script_path = os.path.dirname(os.path.realpath(__file__))
START_FILE=1801
FILES=3600  # There are 3,600 data files
ADAPTOR=1
MIN_SLEEP=5
MAX_SLEEP=20


for x in range(START_FILE, FILES):
  data_file = script_path + "/../test-data-sustained/customer" + str(x) + ".sql"
  load.load_data(str(ADAPTOR), data_file)
  s = random.randint(MIN_SLEEP, MAX_SLEEP)
  print("################ ")
  print("################ file #  : " + str(x))
  print("################ loading : " + data_file)
  print("################ sleeping: " + str(s) + " seconds")
  print("################ ")
  time.sleep(s)
  print( )
