import json
import os

from functions import get_token
from functions import post_zone

#
# Script to create the zones, if they dont' exist.
#

script_path = os.path.dirname(os.path.realpath(__file__))
zones_path = script_path + "/../zones/"


def __create_zone(zone_file, global_file):
    zf = open(zones_path + zone_file, "r")
    gf = open(global_file, "r")

    try:
        json_in = json.load(zf)

        print("\n*** ZONE INFORMATION ***")
        print("Name:         " + json_in["name"])
        print("Parent Zone:  " + json_in["parentZone"])
        print("Admin SSO ID: " + json_in["zoneAdminSsoId"])
        print("DGS SSO ID:   " + json_in["zoneDataStewardSsoId"] + "\n")

        # Get the token

        json_global = json.load(gf)
        values = json_global.get("values")
        token_href = next((x.get("value") for x in values if x.get("key") == "token_href"), None)
        client_id = next((x.get("value") for x in values if x.get("key") == "client_id"), None)
        client_secret = next((x.get("value") for x in values if x.get("key") == "client_secret"), None)
        username = next((x.get("value") for x in values if x.get("key") == "admin_username"), None)
        password = next((x.get("value") for x in values if x.get("key") == "admin_password"), None)
        admin_token = get_token(token_href, client_id, client_secret, username, password)
        if admin_token is None:
            print("Either the Keycloak is down or the credentials for the following user are invalid: admin")

        # Create the zone

        href = next((x.get("value") for x in values if x.get("key") == "href"), None)
        post_zone(href, admin_token, json_in)

    finally:
        zf.close()
        gf.close()

def create_zones(global_file):

    print("Creating Asia Headquarters Zone")
    __create_zone("asia.json", global_file)

    print("Creating North America Headquarters Zone")
    __create_zone("north_america.json", global_file)

    print("Creating Europe Headquarters Zone")
    __create_zone("europe.json", global_file)

