# BI Demo
Shows a BI tool working with YOUnite.

Set ACLs so that no zone can see customer or  employee PII from another zone

Use with a BI tool like Tableau and the biz demo.

## Start Here
Follow the biz demo readme but skip the `Loading Data` step and use the one below.

## Loading Data
```
cd /Users/mark/workspace/younite-db-adaptor/db-adaptor/example/biz
```

```
python3 scripts/load.py -l  -a 1 -f test-data-bi/department.sql
python3 scripts/load.py -l  -a 1 -f test-data-bi/product.sql
```

Set ACLs so that each zone is blocking the other two from Employee and Customer PII. This can be really tedious in the UI so 
`BI Demo.postman_collection.json` can be used instead.

Then run the following to load employee and some customer data:

```
python3 scripts/load.py -l  -a 3 -f test-data-bi/employee-corp.sql
python3 scripts/load.py -l  -a 1 -f test-data-bi/employee-asia.sql
python3 scripts/load.py -l  -a 3 -f test-data-bi/employee-na.sql
python3 scripts/load.py -l  -a 2 -f test-data-bi/employee-eu.sql

python3 scripts/load.py -l  -a 1 -f test-data-bi/employee-department.sql
python3 scripts/load.py -l  -a 1 -f test-data-bi/customer1-asia.sql
python3 scripts/load.py -l  -a 3 -f test-data-bi/customer1-na.sql
python3 scripts/load.py -l  -a 2 -f test-data-bi/customer1-eu.sql
```

Show graphs in Tableau e.g. once data sources are defined, create a two data sources (Asia and Europe - I had a problem 
connecting to NA Postgres DB in Tableau). Then create two worksheets:
* Columns: CNT(customer)
* Rows: Name (department), Last Name (Employee), EmployeeId, Email (Employee), Phone (Employee)

Show results with EU worksheet and Asia worksheet.

Then load more customer data:

```
python3 scripts/load.py -l  -a 1 -f test-data-bi/customer2.sql 
python3 scripts/load.py -l  -a 1 -f test-data-bi/customer2-asia.sql
python3 scripts/load.py -l  -a 3 -f test-data-bi/customer2-na.sql
python3 scripts/load.py -l  -a 2 -f test-data-bi/customer2-eu.sql
```

Refresh and show graph again
