
-- Set any missing service reps
DECLARE
	CURSOR c1 IS
	SELECT customer_id FROM customer WHERE sales_rep_id IS NULL;
	v_employee_id employee.employee_id%TYPE;
BEGIN
	FOR rec
	IN c1
	LOOP
		SELECT employee_id INTO v_employee_id FROM employee sample(10) WHERE rownum = 1;
		UPDATE customer SET sales_rep_id = v_employee_id WHERE customer_id = rec.customer_id;
	END LOOP;
END;
/


-- Add employee departments
DECLARE
	CURSOR c1 IS
	SELECT employee_id FROM EMPLOYEE WHERE (SELECT COUNT(*) FROM department) > 0 MINUS SELECT employee_id FROM EMPLOYEE_DEPARTMENT;
	v_department_id department.department_id%TYPE;
BEGIN
	FOR rec
	IN c1
	LOOP
		SELECT department_id INTO v_department_id FROM department sample(10) WHERE rownum = 1;
		INSERT INTO EMPLOYEE_DEPARTMENT(employee_id, department_id, employee_role)
		VALUES(rec.employee_id, v_department_id, DBMS_RANDOM.string('p',DBMS_RANDOM.value(1, 50)));
	END LOOP;
END;
/

-- Populate any missing product department values
DECLARE
	CURSOR c1 IS
	SELECT product_id FROM product WHERE department_id IS NULL;
	v_department_id department.department_id%TYPE;
BEGIN
	FOR rec
	IN c1
	LOOP
		SELECT department_id INTO v_department_id FROM department sample(10) WHERE rownum = 1;
		UPDATE product SET department_id = v_department_id WHERE product_id = rec.product_id;
	END LOOP;
END;
/